VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ImageProcessing"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' +-------------------------------- DISCLAIMER ---------------------------------+
' |                                                                             |
' | This application program is provided to you free of charge as an example.   |
' | Despite the considerable efforts of Euresys personnel to create a usable    |
' | example, you should not assume that this program is error-free or suitable  |
' | for any purpose whatsoever.                                                 |
' |                                                                             |
' | EURESYS does not give any representation, warranty or undertaking that this |
' | program is free of any defect or error or suitable for any purpose. EURESYS |
' | shall not be liable, in contract, in torts or otherwise, for any damages,   |
' | loss, costs, expenses or other claims for compensation, including those     |
' | asserted by third parties, arising out of or in connection with the use of  |
' | this program.                                                               |
' |                                                                             |
' +-----------------------------------------------------------------------------+

Option Explicit

Option Base 0

' The source image
Private m_SrcImg As New EImageBW8

' The EasyOCR object
Private m_Ocr As New EOCR

' Index of selected pattern
Private m_n32Index As Long

' Character code for selected pattern
Private m_sChar As Long

' Class for selected pattern
Private m_nRecoClasses As Long


Public Sub Initialize()

    On Error GoTo Failure
    
    Dim sPath As String
    
    sPath = Left(App.Path, InStrRev(App.Path, "\") - 6)
    
    ' Load the image featuring the character
    m_SrcImg.Load sPath & "\Resources\font\OCR-B.bmp"
    
    ' Set the contrast (white chars on a black background)
    m_Ocr.TextColor = EOCRColor_WhiteOnBlack
    
    ' Build blobs
    m_Ocr.BuildObjects m_SrcImg
      
    ' Build chars
    m_Ocr.FindAllChars m_SrcImg
     
    On Error GoTo 0
    Exit Sub
    
Failure:
    ' Display the error description
    MsgBox "Error: " & Err.Description, vbOKOnly, "Lot Mixing Learn"
            
End Sub


Public Sub Draw(HDCContext As Long)

    On Error GoTo Failure
      
    ' Exit if no image has been loaded
    If m_SrcImg.IsVoid Then Exit Sub
    
    'Draw the source image
    m_SrcImg.Draw HDCContext
    
    ' Draw character bounding boxes
    m_Ocr.DrawChars HDCContext

   On Error GoTo 0
    Exit Sub

Failure:
    ' Display the error description
    MsgBox "Error: " & Err.Description, vbOKOnly, "Lot Mixing Learn"

End Sub


Public Sub OnDoubleClick(X As Single, Y As Single)

    On Error GoTo Failure
    
    ' Check if a pattern has been selected
    If Not m_Ocr.HitChars(X, Y, m_n32Index) Then Exit Sub

    Dim iRet As VbMsgBoxResult
     
    iRet = CharCodeForm.ShowForm
    
    If iRet = vbCancel Then
        Exit Sub
    Else
        ' Get parameters for learning
        CharCodeForm.GetParameters m_sChar, m_nRecoClasses
        LearnPattern
    End If
    
    Unload CharCodeForm
    
    Set CharCodeForm = Nothing
    
   On Error GoTo 0
    Exit Sub
    
Failure:
    ' Display the error description
    MsgBox "Error: " & Err.Description, vbOKOnly, "Lot Mixing Learn"

End Sub


Public Sub LearnPattern()
    
    On Error GoTo Failure
    
      ' If a class or code  has not been specified, inform about it
      ' and don't do anything.
      If m_nRecoClasses = 0 Or m_sChar = 0 Then
      
           MsgBox "It is mandatory to select a character class and code. \nThe character has not been added  to the font. "
          Exit Sub

      End If
    
    ' Add the pattern to the font
    m_Ocr.LearnPattern m_SrcImg, m_n32Index, m_sChar, m_nRecoClasses
    
    On Error GoTo 0
        Exit Sub
    
Failure:
    ' Display the error description
    MsgBox "Error: " & Err.Description, vbOKOnly, "Lot Mixing Learn"


End Sub


Public Sub SaveFontFile(mFilename As String)

    On Error GoTo Failure

    'Save the font file
     m_Ocr.Save (mFilename)
         
   On Error GoTo 0
    Exit Sub
    
Failure:
    ' Display the error description
    MsgBox "Error: " & Err.Description, vbOKOnly, "Lot Mixing Learn"

End Sub



