// +-------------------------------- DISCLAIMER ---------------------------------+
// |                                                                             |
// | This application program is provided to you free of charge as an example.   |
// | Despite the considerable efforts of Euresys personnel to create a usable    |
// | example, you should not assume that this program is error-free or suitable  |
// | for any purpose whatsoever.                                                 |
// |                                                                             |
// | EURESYS does not give any representation, warranty or undertaking that this |
// | program is free of any defect or error or suitable for any purpose. EURESYS |
// | shall not be liable, in contract, in torts or otherwise, for any damages,   |
// | loss, costs, expenses or other claims for compensation, including those     |
// | asserted by third parties, arising out of or in connection with the use of  |
// | this program.                                                               |
// |                                                                             |
// +-----------------------------------------------------------------------------+
//
// OcrFontExplorerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "OcrFontExplorer.h"
#include "OcrFontExplorerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COcrFontExplorerDlg dialog

COcrFontExplorerDlg::COcrFontExplorerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COcrFontExplorerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COcrFontExplorerDlg)
	m_bDigit = FALSE;
	m_bLowerCase = FALSE;
	m_bUpperCase = FALSE;
	m_bSpecial = FALSE;
	m_bExtended = FALSE;
	m_sFilename = _T("");
	m_nPatIndex = 0;
	m_sAssocChar = _T("");
	m_nNumPat = 0;
	m_nGotoIndex = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

}


void COcrFontExplorerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COcrFontExplorerDlg)
	DDX_Check(pDX, IDC_CHECK_OCRDIGIT, m_bDigit);
	DDX_Check(pDX, IDC_CHECK_LOWERCASE, m_bLowerCase);
	DDX_Check(pDX, IDC_CHECK_OCRUPPERCASE, m_bUpperCase);
	DDX_Check(pDX, IDC_CHECK_OCRSPECIAL, m_bSpecial);
	DDX_Check(pDX, IDC_CHECK_EXTENDED, m_bExtended);
	DDX_Text(pDX, IDC_EDIT_FONTFILENAME, m_sFilename);
	DDX_Text(pDX, IDC_EDIT_CURRPATINDEX, m_nPatIndex);
	DDX_Text(pDX, IDC_EDIT_ASSOCCHAR, m_sAssocChar);
	DDX_Text(pDX, IDC_EDIT_NUMPAT, m_nNumPat);
	DDX_Text(pDX, IDC_EDIT_GOTOINDEX, m_nGotoIndex);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COcrFontExplorerDlg, CDialog)
	//{{AFX_MSG_MAP(COcrFontExplorerDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(IDM_FILE_LOADFONTFILE, OnFileLoadfontfile)
	ON_COMMAND(ID_FILE_SAVEFONTFILE, OnFileSavefontfile)
	ON_BN_CLICKED(IDC_BUTTON_PREVIOUSPAT, OnButtonPreviouspat)
	ON_BN_CLICKED(IDC_BUTTON_NEXTPAT, OnButtonNextpat)
	ON_BN_CLICKED(IDC_BUTTON_GOTOINDEX, OnButtonGotoindex)
    ON_COMMAND(IDM_FILE_EXIT,OnFileExit)
	ON_BN_CLICKED(IDC_BUTTON_REMOVEPATTERN, OnButtonRemovepattern)
	//}}AFX_MSG_MAP

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COcrFontExplorerDlg message handlers

void COcrFontExplorerDlg::OnFileExit()
{
	EndDialog(0);

}


BOOL COcrFontExplorerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

    m_Menu.LoadMenu(IDR_MENU1);
    SetMenu(&m_Menu);

	m_SrcImg= new EImageBW8();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void COcrFontExplorerDlg::OnPaint()
{

	CPaintDC dc(this); // device context for painting

	if (IsIconic())
	{

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{

		CDialog::OnPaint();

		/// Exit if no image has been loaded
		if (m_SrcImg->IsVoid())
			return;

		/// Draw the current pattern
		m_SrcImg->Draw(dc.GetSafeHdc(), 60.0f/m_SrcImg->GetWidth(), 90.0f/m_SrcImg->GetHeight(), 550, 50);

	}
}


// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR COcrFontExplorerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void COcrFontExplorerDlg::OnFileLoadfontfile()
{

	char strFilter[] = { "ocr Files (*.ocr)|*.ocr|" };

	CFileDialog FileDlg(TRUE, ".ocr", NULL, 0, strFilter);


	if( FileDlg.DoModal() == IDOK )
	{

		/// Load the font file
		m_Ocr.Load(FileDlg.GetPathName().GetBuffer(0));
		
		/// Get the filename for display
		m_sFilename = FileDlg.GetPathName( ) ;

		/// Retrieve the number of patterns in font
		m_nNumPat = m_Ocr.GetNumPatterns();
		m_nPatIndex = 0;

		/// Retrieve the current pattern info
		GetPatternInfo(SetCurrentPatternIndex(m_nPatIndex, m_nAssocChar));

	}

}


void COcrFontExplorerDlg::OnFileSavefontfile()
{
	// TODO: Add your command handler code here
	char strFilter[] = { "ocr Files (*.ocr)|*.ocr|" };

	CFileDialog FileDlg(FALSE, ".ocr", NULL, 0, strFilter);

	if( FileDlg.DoModal() == IDOK )
	{

		/// Save the modified font file
		m_Ocr.Save(FileDlg.GetFileName().GetBuffer(0));

		/// Refresh the window
		Invalidate();

	}

}


UINT32 COcrFontExplorerDlg::SetCurrentPatternIndex(int index, int& ch)
{

	try
	{

		/// Retrieve the font pattern size
		int m_un32PatternWidth= m_Ocr.GetPatternWidth();
		int m_un32PatternHeight= m_Ocr.GetPatternHeight();

		/// Retrieve the current pattern bitmap pointer
		m_SrcImg = m_Ocr.GetPatternBitmap(index);

		/// Retrieve the current pattern code
		ch = m_Ocr.GetPatternCode(index);

		/// Retrieve the current pattern class
		return m_Ocr.GetPatternClass(index);

	}
	catch(EException exc)
	{
		::MessageBox(NULL, exc.What().c_str(), "Error", MB_OK | MB_ICONERROR);
		return NULL;
	}

}


void COcrFontExplorerDlg::GetPatternInfo(UINT32 classes)
{

	/// Update the character code
	m_sAssocChar.Format("%c", static_cast<char>(m_nAssocChar));


	/// Update the pattern class
	m_bDigit= FALSE;
	m_bUpperCase= FALSE;
	m_bLowerCase= FALSE;
	m_bSpecial= FALSE;
	m_bExtended= FALSE;

	if(EOCRClass_Digit & classes)m_bDigit= TRUE;
	if(EOCRClass_UpperCase & classes)m_bUpperCase= TRUE;
	if(EOCRClass_LowerCase & classes)m_bLowerCase= TRUE;
	if(EOCRClass_Special & classes)m_bSpecial= TRUE;
	if(EOCRClass_Extended & classes)m_bExtended= TRUE;
	
	/// Update the form controls
	UpdateData(FALSE);

	/// Refresh the window
	Invalidate();

}


void COcrFontExplorerDlg::OnButtonPreviouspat()
{

	if(m_nNumPat==0)
		return;

	m_nPatIndex--;

	if(m_nPatIndex <0)
		m_nPatIndex =0;

	/// Retrieve the current pattern info
	GetPatternInfo(SetCurrentPatternIndex(m_nPatIndex, m_nAssocChar));

}


void COcrFontExplorerDlg::OnButtonNextpat()
{

	if(m_nNumPat==0)
		return;

	m_nPatIndex++;

	if(m_nPatIndex > m_nNumPat-1)
		m_nPatIndex =m_nNumPat-1;

	/// Retrieve the current pattern info
	GetPatternInfo(SetCurrentPatternIndex(m_nPatIndex, m_nAssocChar));


}

void COcrFontExplorerDlg::OnButtonGotoindex()
{

	if(m_nNumPat==0)
		return;

	/// Update the form control values
	UpdateData(TRUE);

	m_nPatIndex = m_nGotoIndex;

	if(m_nPatIndex <0)
		m_nPatIndex =0;

	if(m_nPatIndex > m_nNumPat-1)
		m_nPatIndex =m_nNumPat-1;

	/// Retrieve the current pattern info
	GetPatternInfo(SetCurrentPatternIndex(m_nPatIndex, m_nAssocChar));

}


void COcrFontExplorerDlg::OnButtonRemovepattern()
{
	/// If no pattern in the font, exit
	if(m_nNumPat==0)
		return;

	/// Remove the current pattern from the font
	m_Ocr.RemovePattern(m_nPatIndex);

	/// Retrieve the number of patterns in the font
	m_nNumPat = m_Ocr.GetNumPatterns();

	/// the last pattern was deleted
	if(m_nNumPat==0)
	{
		m_nPatIndex = 0;

		/// Update the form control values
		UpdateData(FALSE);
		
		/// Refresh the window
		Invalidate();
		
		return;
	}


	if(m_nPatIndex > m_nNumPat-1)
		m_nPatIndex =m_nNumPat-1;


	/// Retrieve the current pattern info
	GetPatternInfo(SetCurrentPatternIndex(m_nPatIndex, m_nAssocChar));

}
