// +-------------------------------- DISCLAIMER ---------------------------------+
// |                                                                             |
// | This application program is provided to you free of charge as an example.   |
// | Despite the considerable efforts of Euresys personnel to create a usable    |
// | example, you should not assume that this program is error-free or suitable  |
// | for any purpose whatsoever.                                                 |
// |                                                                             |
// | EURESYS does not give any representation, warranty or undertaking that this |
// | program is free of any defect or error or suitable for any purpose. EURESYS |
// | shall not be liable, in contract, in torts or otherwise, for any damages,   |
// | loss, costs, expenses or other claims for compensation, including those     |
// | asserted by third parties, arising out of or in connection with the use of  |
// | this program.                                                               |
// |                                                                             |
// +-----------------------------------------------------------------------------+

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace LotMixingLearn
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
    public class MainForm : System.Windows.Forms.Form
    {
        private System.Windows.Forms.SaveFileDialog  saveFileDialog;
        private System.Windows.Forms.MainMenu mainMenu;
        private System.Windows.Forms.MenuItem File;
        private System.Windows.Forms.MenuItem SaveFont;
        private System.Windows.Forms.MenuItem FileExit;
        private System.Windows.Forms.MenuItem menuItem1;

        private ImageProcessing m_Process = new ImageProcessing();

        private IContainer components;

        public MainForm()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            //
            // TODO: Add any constructor code after InitializeComponent call

        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.saveFileDialog = new System.Windows.Forms.SaveFileDialog();
            this.mainMenu = new System.Windows.Forms.MainMenu(this.components);
            this.File = new System.Windows.Forms.MenuItem();
            this.SaveFont = new System.Windows.Forms.MenuItem();
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.FileExit = new System.Windows.Forms.MenuItem();
            this.SuspendLayout();
            // 
            // mainMenu
            // 
            this.mainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.File});
            // 
            // File
            // 
            this.File.Index = 0;
            this.File.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.SaveFont,
            this.menuItem1,
            this.FileExit});
            this.File.Text = "File";
            // 
            // SaveFont
            // 
            this.SaveFont.Index = 0;
            this.SaveFont.Text = "Save Font File";
            this.SaveFont.Click += new System.EventHandler(this.SaveFont_Click);
            // 
            // menuItem1
            // 
            this.menuItem1.Index = 1;
            this.menuItem1.Text = "-";
            // 
            // FileExit
            // 
            this.FileExit.Index = 2;
            this.FileExit.Text = "Exit";
            this.FileExit.Click += new System.EventHandler(this.FileExit_Click);
            // 
            // MainForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(566, 483);
            this.Menu = this.mainMenu;
            this.Name = "MainForm";
            this.Text = "Lot Mixing Learn";
            this.Load += new System.EventHandler(this.MainForm_Load);
            this.Paint += new System.Windows.Forms.PaintEventHandler(this.MainForm_Paint);
            this.MouseDown += new System.Windows.Forms.MouseEventHandler(this.MainForm_MouseDown);
            this.ResumeLayout(false);

        }
        #endregion

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.Run(new MainForm());
        }

        private void MainForm_Load(object sender, System.EventArgs e)
        {
            /// Call the Initialize function of the ImageProcessing class
            m_Process.Initialize();

        }

        private void MainForm_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
        {
            /// Call the Draw function of the ImageProcessing class
            m_Process.Draw(e.Graphics);
        }

        private void SaveFont_Click(object sender, System.EventArgs e)
        {
            /// Show the Save File dialog
            saveFileDialog.Filter = "OCR Files (*.ocr)|*.ocr";

            if (saveFileDialog.ShowDialog() == DialogResult.OK )
            {
                /// Call the SaveFontFile function of the ImageProcessing class
                m_Process.SaveFontFile(saveFileDialog.FileName);
            }

            /// Refresh the form
            Refresh();
        }

        private void FileExit_Click(object sender, System.EventArgs e)
        {
            /// Close the form
            Close();
        }

        private void MainForm_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Clicks == 2)
            {
                /// Call the DoubleClick function of the ImageProcessing class
                m_Process.OnLButtonDblClk(sender, e);

            }
        }

    }
}


