// +-------------------------------- DISCLAIMER ---------------------------------+
// |                                                                             |
// | This application program is provided to you free of charge as an example.   |
// | Despite the considerable efforts of Euresys personnel to create a usable    |
// | example, you should not assume that this program is error-free or suitable  |
// | for any purpose whatsoever.                                                 |
// |                                                                             |
// | EURESYS does not give any representation, warranty or undertaking that this |
// | program is free of any defect or error or suitable for any purpose. EURESYS |
// | shall not be liable, in contract, in torts or otherwise, for any damages,   |
// | loss, costs, expenses or other claims for compensation, including those     |
// | asserted by third parties, arising out of or in connection with the use of  |
// | this program.                                                               |
// |                                                                             |
// +-----------------------------------------------------------------------------+

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

/// Open eVision Namespace
using Euresys.Open_eVision_1_2;

namespace OcrFontExplorer
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
    public class MainForm : System.Windows.Forms.Form
    {
        private System.Windows.Forms.OpenFileDialog openFileDialog;
        private System.Windows.Forms.SaveFileDialog saveFileDialog;
        private System.Windows.Forms.MainMenu mainMenu;
        private System.Windows.Forms.MenuItem File;
        private System.Windows.Forms.MenuItem LoadFont;
        private System.Windows.Forms.MenuItem FileExit;
        private System.Windows.Forms.MenuItem menuItem1;

        private GroupBox groupBox1;
        private GroupBox groupBox2;
        private Label label4;
        private Label label3;
        private Label label2;
        private Label label1;
        private CheckBox checkBoxExtended;
        private CheckBox checkBoxSpecial;
        private CheckBox checkBoxLowerCase;
        private CheckBox checkBoxUpperCase;
        private CheckBox checkBoxDigit;
        private TextBox textBoxFilename;
        private TextBox textBoxTotNumPat;
        private TextBox textBoxCurrPatIdx;
        private TextBox textBoxAssocChar;
        private TextBox textBoxGoto;
        private Button buttonGoto;
        private Button buttonRemPat;
        private Button buttonNextPat;
        private Button buttonPreviousPat;
        private MenuItem SaveFont;
        private IContainer components;

        /// Source image
        private EImageBW8 m_SrcImg = new EImageBW8();

        /// EasyOCR Object
        public EOCR m_Ocr = new EOCR();

        private int m_nPatIndex = 0;
        private int m_nAssocChar;
        private int m_nNumPat;

        public MainForm()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            //
            // TODO: Add any constructor code after InitializeComponent call

        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #region Windows Form Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
            this.saveFileDialog = new System.Windows.Forms.SaveFileDialog();
            this.mainMenu = new System.Windows.Forms.MainMenu(this.components);
            this.File = new System.Windows.Forms.MenuItem();
            this.LoadFont = new System.Windows.Forms.MenuItem();
            this.SaveFont = new System.Windows.Forms.MenuItem();
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.FileExit = new System.Windows.Forms.MenuItem();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.textBoxTotNumPat = new System.Windows.Forms.TextBox();
            this.textBoxCurrPatIdx = new System.Windows.Forms.TextBox();
            this.textBoxAssocChar = new System.Windows.Forms.TextBox();
            this.label3 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.label1 = new System.Windows.Forms.Label();
            this.checkBoxExtended = new System.Windows.Forms.CheckBox();
            this.checkBoxSpecial = new System.Windows.Forms.CheckBox();
            this.checkBoxLowerCase = new System.Windows.Forms.CheckBox();
            this.checkBoxUpperCase = new System.Windows.Forms.CheckBox();
            this.checkBoxDigit = new System.Windows.Forms.CheckBox();
            this.textBoxFilename = new System.Windows.Forms.TextBox();
            this.label4 = new System.Windows.Forms.Label();
            this.groupBox2 = new System.Windows.Forms.GroupBox();
            this.textBoxGoto = new System.Windows.Forms.TextBox();
            this.buttonGoto = new System.Windows.Forms.Button();
            this.buttonRemPat = new System.Windows.Forms.Button();
            this.buttonNextPat = new System.Windows.Forms.Button();
            this.buttonPreviousPat = new System.Windows.Forms.Button();
            this.groupBox1.SuspendLayout();
            this.groupBox2.SuspendLayout();
            this.SuspendLayout();
            // 
            // mainMenu
            // 
            this.mainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.File});
            // 
            // File
            // 
            this.File.Index = 0;
            this.File.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.LoadFont,
            this.SaveFont,
            this.menuItem1,
            this.FileExit});
            this.File.Text = "File";
            // 
            // LoadFont
            // 
            this.LoadFont.Index = 0;
            this.LoadFont.Text = "Load Font File";
            this.LoadFont.Click += new System.EventHandler(this.LoadFont_Click);
            // 
            // SaveFont
            // 
            this.SaveFont.Index = 1;
            this.SaveFont.Text = "Save Font File";
            this.SaveFont.Click += new System.EventHandler(this.SaveFont_Click);
            // 
            // menuItem1
            // 
            this.menuItem1.Index = 2;
            this.menuItem1.Text = "-";
            // 
            // FileExit
            // 
            this.FileExit.Index = 3;
            this.FileExit.Text = "Exit";
            this.FileExit.Click += new System.EventHandler(this.FileExit_Click);
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.textBoxTotNumPat);
            this.groupBox1.Controls.Add(this.textBoxCurrPatIdx);
            this.groupBox1.Controls.Add(this.textBoxAssocChar);
            this.groupBox1.Controls.Add(this.label3);
            this.groupBox1.Controls.Add(this.label2);
            this.groupBox1.Controls.Add(this.label1);
            this.groupBox1.Controls.Add(this.checkBoxExtended);
            this.groupBox1.Controls.Add(this.checkBoxSpecial);
            this.groupBox1.Controls.Add(this.checkBoxLowerCase);
            this.groupBox1.Controls.Add(this.checkBoxUpperCase);
            this.groupBox1.Controls.Add(this.checkBoxDigit);
            this.groupBox1.Location = new System.Drawing.Point(21, 37);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(472, 148);
            this.groupBox1.TabIndex = 0;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "OCR Information";
            // 
            // textBoxTotNumPat
            // 
            this.textBoxTotNumPat.Location = new System.Drawing.Point(331, 95);
            this.textBoxTotNumPat.Name = "textBoxTotNumPat";
            this.textBoxTotNumPat.Size = new System.Drawing.Size(81, 20);
            this.textBoxTotNumPat.TabIndex = 11;
            // 
            // textBoxCurrPatIdx
            // 
            this.textBoxCurrPatIdx.Location = new System.Drawing.Point(331, 58);
            this.textBoxCurrPatIdx.Name = "textBoxCurrPatIdx";
            this.textBoxCurrPatIdx.Size = new System.Drawing.Size(81, 20);
            this.textBoxCurrPatIdx.TabIndex = 10;
            // 
            // textBoxAssocChar
            // 
            this.textBoxAssocChar.Location = new System.Drawing.Point(331, 26);
            this.textBoxAssocChar.Name = "textBoxAssocChar";
            this.textBoxAssocChar.Size = new System.Drawing.Size(81, 20);
            this.textBoxAssocChar.TabIndex = 9;
            // 
            // label3
            // 
            this.label3.AutoSize = true;
            this.label3.Location = new System.Drawing.Point(190, 95);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(125, 13);
            this.label3.TabIndex = 7;
            this.label3.Text = "Total Number of Patterns";
            // 
            // label2
            // 
            this.label2.AutoSize = true;
            this.label2.Location = new System.Drawing.Point(190, 58);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(107, 13);
            this.label2.TabIndex = 6;
            this.label2.Text = "Current Pattern Index";
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Location = new System.Drawing.Point(190, 26);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(81, 13);
            this.label1.TabIndex = 5;
            this.label1.Text = "Character Code";
            // 
            // checkBoxExtended
            // 
            this.checkBoxExtended.AutoSize = true;
            this.checkBoxExtended.Location = new System.Drawing.Point(16, 118);
            this.checkBoxExtended.Name = "checkBoxExtended";
            this.checkBoxExtended.Size = new System.Drawing.Size(140, 17);
            this.checkBoxExtended.TabIndex = 4;
            this.checkBoxExtended.Text = "OCR Extended (Class 4)";
            this.checkBoxExtended.UseVisualStyleBackColor = true;
            // 
            // checkBoxSpecial
            // 
            this.checkBoxSpecial.AutoSize = true;
            this.checkBoxSpecial.Location = new System.Drawing.Point(16, 94);
            this.checkBoxSpecial.Name = "checkBoxSpecial";
            this.checkBoxSpecial.Size = new System.Drawing.Size(130, 17);
            this.checkBoxSpecial.TabIndex = 3;
            this.checkBoxSpecial.Text = "OCR Special (Class 3)";
            this.checkBoxSpecial.UseVisualStyleBackColor = true;
            // 
            // checkBoxLowerCase
            // 
            this.checkBoxLowerCase.AutoSize = true;
            this.checkBoxLowerCase.Location = new System.Drawing.Point(16, 70);
            this.checkBoxLowerCase.Name = "checkBoxLowerCase";
            this.checkBoxLowerCase.Size = new System.Drawing.Size(148, 17);
            this.checkBoxLowerCase.TabIndex = 2;
            this.checkBoxLowerCase.Text = "OCR LowerCase (Class 2)";
            this.checkBoxLowerCase.UseVisualStyleBackColor = true;
            // 
            // checkBoxUpperCase
            // 
            this.checkBoxUpperCase.AutoSize = true;
            this.checkBoxUpperCase.Location = new System.Drawing.Point(16, 46);
            this.checkBoxUpperCase.Name = "checkBoxUpperCase";
            this.checkBoxUpperCase.Size = new System.Drawing.Size(148, 17);
            this.checkBoxUpperCase.TabIndex = 1;
            this.checkBoxUpperCase.Text = "OCR UpperCase (Class 1)";
            this.checkBoxUpperCase.UseVisualStyleBackColor = true;
            // 
            // checkBoxDigit
            // 
            this.checkBoxDigit.AutoSize = true;
            this.checkBoxDigit.Location = new System.Drawing.Point(16, 22);
            this.checkBoxDigit.Name = "checkBoxDigit";
            this.checkBoxDigit.Size = new System.Drawing.Size(116, 17);
            this.checkBoxDigit.TabIndex = 0;
            this.checkBoxDigit.Text = "OCR Digit (Class 0)";
            this.checkBoxDigit.UseVisualStyleBackColor = true;
            // 
            // textBoxFilename
            // 
            this.textBoxFilename.Location = new System.Drawing.Point(141, 6);
            this.textBoxFilename.Name = "textBoxFilename";
            this.textBoxFilename.Size = new System.Drawing.Size(352, 20);
            this.textBoxFilename.TabIndex = 12;
            // 
            // label4
            // 
            this.label4.AutoSize = true;
            this.label4.Location = new System.Drawing.Point(18, 9);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(73, 13);
            this.label4.TabIndex = 8;
            this.label4.Text = "Font Filename";
            // 
            // groupBox2
            // 
            this.groupBox2.Controls.Add(this.textBoxGoto);
            this.groupBox2.Controls.Add(this.buttonGoto);
            this.groupBox2.Controls.Add(this.buttonRemPat);
            this.groupBox2.Controls.Add(this.buttonNextPat);
            this.groupBox2.Controls.Add(this.buttonPreviousPat);
            this.groupBox2.Location = new System.Drawing.Point(21, 191);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new System.Drawing.Size(637, 57);
            this.groupBox2.TabIndex = 1;
            this.groupBox2.TabStop = false;
            this.groupBox2.Text = "Pattern";
            // 
            // textBoxGoto
            // 
            this.textBoxGoto.Location = new System.Drawing.Point(520, 19);
            this.textBoxGoto.Name = "textBoxGoto";
            this.textBoxGoto.Size = new System.Drawing.Size(102, 20);
            this.textBoxGoto.TabIndex = 4;
            // 
            // buttonGoto
            // 
            this.buttonGoto.Location = new System.Drawing.Point(375, 19);
            this.buttonGoto.Name = "buttonGoto";
            this.buttonGoto.Size = new System.Drawing.Size(114, 25);
            this.buttonGoto.TabIndex = 3;
            this.buttonGoto.Text = "Go to Index";
            this.buttonGoto.UseVisualStyleBackColor = true;
            this.buttonGoto.Click += new System.EventHandler(this.buttonGoto_Click);
            // 
            // buttonRemPat
            // 
            this.buttonRemPat.Location = new System.Drawing.Point(255, 19);
            this.buttonRemPat.Name = "buttonRemPat";
            this.buttonRemPat.Size = new System.Drawing.Size(114, 25);
            this.buttonRemPat.TabIndex = 2;
            this.buttonRemPat.Text = "Remove Pattern";
            this.buttonRemPat.UseVisualStyleBackColor = true;
            this.buttonRemPat.Click += new System.EventHandler(this.buttonRemPat_Click);
            // 
            // buttonNextPat
            // 
            this.buttonNextPat.Location = new System.Drawing.Point(135, 19);
            this.buttonNextPat.Name = "buttonNextPat";
            this.buttonNextPat.Size = new System.Drawing.Size(114, 25);
            this.buttonNextPat.TabIndex = 1;
            this.buttonNextPat.Text = "Next Pattern >>";
            this.buttonNextPat.UseVisualStyleBackColor = true;
            this.buttonNextPat.Click += new System.EventHandler(this.buttonNextPat_Click);
            // 
            // buttonPreviousPat
            // 
            this.buttonPreviousPat.Location = new System.Drawing.Point(16, 19);
            this.buttonPreviousPat.Name = "buttonPreviousPat";
            this.buttonPreviousPat.Size = new System.Drawing.Size(114, 25);
            this.buttonPreviousPat.TabIndex = 0;
            this.buttonPreviousPat.Text = "<< Previous Pattern";
            this.buttonPreviousPat.UseVisualStyleBackColor = true;
            this.buttonPreviousPat.Click += new System.EventHandler(this.buttonPreviousPat_Click);
            // 
            // MainForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(678, 257);
            this.Controls.Add(this.groupBox2);
            this.Controls.Add(this.textBoxFilename);
            this.Controls.Add(this.groupBox1);
            this.Controls.Add(this.label4);
            this.Menu = this.mainMenu;
            this.Name = "MainForm";
            this.Text = "Ocr Font Explorer";
            this.Paint += new System.Windows.Forms.PaintEventHandler(this.MainForm_Paint);
            this.groupBox1.ResumeLayout(false);
            this.groupBox1.PerformLayout();
            this.groupBox2.ResumeLayout(false);
            this.groupBox2.PerformLayout();
            this.ResumeLayout(false);
            this.PerformLayout();

        }
        #endregion

        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.Run(new MainForm());
        }

        private void MainForm_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
        {
            try
            {
                /// Exit if no image has been loaded
                if (m_SrcImg.IsVoid)
                    return;

                /// Draw the current pattern
                m_SrcImg.Draw(CreateGraphics(), 60.0f / m_SrcImg.Width, 90.0f / m_SrcImg.Height, 550, 50);

            }
            catch (EException exc)
            {
                MessageBox.Show(exc.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void LoadFont_Click(object sender, System.EventArgs e)
        {
            // Show the Open File dialog
            openFileDialog.Filter = "OCR Files (*.ocr)|*.ocr";

            if (openFileDialog.ShowDialog() == DialogResult.OK)
            {
                /// Load the font file
                m_Ocr.Load(openFileDialog.FileName);

                /// Get the filename for display
                textBoxFilename.Text = openFileDialog.FileName;
                m_nPatIndex = 0;

                /// Retrieve the number of patterns in the font
                m_nNumPat = m_Ocr.NumPatterns;
                textBoxTotNumPat.Text = m_nNumPat.ToString();

                /// Retrieve the current pattern info
                GetPatternInfo(SetCurrentPatternIndex(m_nPatIndex, out m_nAssocChar));
            }

            /// Refresh the form
            Refresh();
        }

        private void FileExit_Click(object sender, System.EventArgs e)
        {
            // Close the form
            Close();
        }

        private void SaveFont_Click(object sender, EventArgs e)
        {
            // Show the Save File dialog
            saveFileDialog.Filter = "OCR Files (*.ocr)|*.ocr";

            if (saveFileDialog.ShowDialog() == DialogResult.Cancel)
            {
                /// Save the modified font file
                m_Ocr.Save(saveFileDialog.FileName);

                return;
            }

            /// Refresh the form
            Refresh();
        }

        public int SetCurrentPatternIndex(int index, out int ch)
        {
            /// Retrieve the font pattern size
            int m_un32PatternWidth = m_Ocr.PatternWidth;
            int m_un32PatternHeight = m_Ocr.PatternHeight;

            try
            {
                /// Retrieve the current pattern bitmap pointer
                m_SrcImg = m_Ocr.GetPatternBitmap(index);

            }
            catch (EException exc)
            {
                MessageBox.Show(exc.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }

            /// Retrieve the current pattern code
            ch = m_Ocr.GetPatternCode(index);

            /// Retrieve the current pattern class
            return m_Ocr.GetPatternClass(index);

        }

        public void GetPatternInfo(int classes) 
        {

            /// Update the current index
            textBoxCurrPatIdx.Text  = m_nPatIndex.ToString() ;

            /// Update the character code
            textBoxAssocChar.Text = Convert.ToChar(m_nAssocChar).ToString();

            /// Update the pattern class
            checkBoxDigit.Checked = false;
            checkBoxUpperCase.Checked = false;
            checkBoxLowerCase.Checked = false;
            checkBoxSpecial.Checked = false;
            checkBoxExtended.Checked = false;

            if (((int)EOCRClass.Digit & classes)!=0) checkBoxDigit.Checked = true;
            if (((int)EOCRClass.UpperCase & classes)!=0) checkBoxUpperCase.Checked = true;
            if (((int)EOCRClass.LowerCase & classes)!=0) checkBoxLowerCase.Checked = true;
            if (((int)EOCRClass.Special & classes)!=0) checkBoxSpecial.Checked = true;
            if (((int)EOCRClass.Extended & classes)!=0) checkBoxExtended.Checked = true;
	          
            /// Refresh the window		
            Invalidate();      	
        }

        private void buttonPreviousPat_Click(object sender, EventArgs e)
        {
            /// If no pattern in font, exit
            if (m_nNumPat == 0)
                return;

            m_nPatIndex--;

            if (m_nPatIndex < 0)
                m_nPatIndex = 0;

            /// Retrieve the current pattern info
            GetPatternInfo(SetCurrentPatternIndex(m_nPatIndex, out m_nAssocChar));
        }

        private void buttonNextPat_Click(object sender, EventArgs e)
        {
            /// If no pattern in font, exit
            if (m_nNumPat == 0)
                return;

            m_nPatIndex++;

            if (m_nPatIndex > m_nNumPat - 1)
                m_nPatIndex = m_nNumPat - 1;

            /// Retrieve the current pattern info
            GetPatternInfo(SetCurrentPatternIndex(m_nPatIndex, out m_nAssocChar));

        }

        private void buttonRemPat_Click(object sender, EventArgs e)
        {
            /// If no pattern in font, exit
            if (m_nNumPat == 0)
                return;

            /// Remove the pattern from memory
            m_Ocr.RemovePattern(m_nPatIndex);

            /// Retrieve the number of patterns in the font
            m_nNumPat = m_Ocr.NumPatterns;
            textBoxTotNumPat.Text = m_nNumPat.ToString();

            if (m_nNumPat == 0)
            {
                /// Refresh the window		
                m_nPatIndex = 0;
                Refresh();
                return;
            }

            if (m_nPatIndex > m_nNumPat - 1)
                m_nPatIndex = m_nNumPat - 1;

            /// Retrieve the current pattern info
            GetPatternInfo(SetCurrentPatternIndex(m_nPatIndex, out m_nAssocChar));
        }

        private void buttonGoto_Click(object sender, EventArgs e)
        {
            /// If no pattern in font, exit
            if (m_nNumPat == 0)
                return;

            m_nPatIndex = Convert.ToInt16(textBoxGoto.Text);

            if (m_nPatIndex < 0)
                m_nPatIndex = 0;

            if (m_nPatIndex > m_nNumPat - 1)
                m_nPatIndex = m_nNumPat - 1;

            /// Retrieve the current pattern info
            GetPatternInfo(SetCurrentPatternIndex(m_nPatIndex, out m_nAssocChar));
        }

    }
}


